function [Hu_max,Hxm_max,Hxdotdotam_max,HJ6,HJ7,HJ8,HJ9,HJ10] = eval_h(zout,usignal)

%#########################################################################

%  gains: units ---> volts 
  
gain_x_floor = .51;
gain_x_act   = .51;
gain_v_floor = .0204;
gain_v_act   = .0204;
gain_a_floor = 1.0;
gain_a_act   = 0.1;

%#########################################################################
% Peak Responses for the Hachinohe Earthquake:

%************************************************************************
% Calculate the Control Contstraints:

% Max of usignal should be less than or equal to 3 volts:

	Hu_max = max(abs(usignal));

% Max displacement should be less than or equal to 9 cm:

	Hxm_max = max(abs(zout(:,4)/gain_x_act));

% Max acceleration should be less than or equal to 6 g's:

	Hxdotdotam_max = max(abs(zout(:,12)/gain_a_act));

%************************************************************************
% Calculate the values of J:

%------------------------------------------------------------------------
% HJ6:

	Hx3o = 1.66;

	Hd1 = zout(:,1)/gain_x_floor;
	Hd1_max = max(abs(Hd1));

	Hd2 = zout(:,2)/gain_x_floor - zout(:,1)/gain_x_floor;
	Hd2_max = max(abs(Hd2));

	Hd3 = zout(:,3)/gain_x_floor - zout(:,2)/gain_x_floor;
	Hd3_max = max(abs(Hd3));

	Hd = [Hd1_max Hd2_max Hd3_max]/Hx3o;
	HJ6 = max(Hd);

%------------------------------------------------------------------------
% HJ7:

	Hxdotdota3o = 2.58;

	Hxdotdota1 = zout(:,9)/gain_a_floor;
	Hxdotdota1_max = max(abs(Hxdotdota1));

	Hxdotdota2 = zout(:,10)/gain_a_floor;
	Hxdotdota2_max = max(abs(Hxdotdota2));

	Hxdotdota3 = zout(:,11)/gain_a_floor;
	Hxdotdota3_max = max(abs(Hxdotdota3));

	Hxdotdota = [Hxdotdota1_max Hxdotdota2_max Hxdotdota3_max]/Hxdotdota3o;
	HJ7 = max(Hxdotdota);

%------------------------------------------------------------------------
% HJ8:

	Hxm = zout(:,4)/gain_x_act;
	HJ8 = max(abs(Hxm)/Hx3o);

%------------------------------------------------------------------------
% HJ9:

	Hxdot3o = 58.3;

	Hxdotm = zout(:,8)/gain_v_act;
	HJ9 = max(abs(Hxdotm)/Hxdot3o);

%------------------------------------------------------------------------
% HJ10:

	Hxdotdotm = zout(:,12)/gain_a_act;
	HJ10 = max(abs(Hxdotdotm)/Hxdotdota3o);

%************************************************************************
% Save  variables:

	%time_h = time;
	%usignal_h = usignal;
	%zout_h = zout;

