% fuzzy controller for the benchmarck problem
%      Marco Battaini 30/11/96
%     Note that in this problem, the fuzzy input quantity
%     is x (state acceleration and velocity); the fuzzy output 
%     is the control signal F
%     si deve lanciare prima: regole.m pe rinizializzare 
%     le fuzzy rules


   function us = futvel(x)

t = x(4,1);

Tsamp = 0.001;

if abs(round(t/Tsamp)-(t/Tsamp)) < 1e+8*eps


%%  x(2,1) = velocity 2
%%  x(3,1) = velocity 3
%%  x(4,1) = integration step

% --- --- Fuzzify the input response
%           -- Normalize input

global D1 V1 B1 vel2_U vel3_U force1_U     

%% coefficients to be applied to the input variables

%eaj -- original code commented out
%eaj   maxvel2 = 2.678;
%eaj   maxvel3 = 0.334;
%eaj -- new code
global maxvel2 maxvel3
%eaj -- end of new code

     vel2 = x(2,1)/maxvel2;
     vel3 = x(3,1)/maxvel3;

% --- --- Apply fuzzy rules to find the consequence
 
     ALSO=1;
     AND=1;
 
  [fuzzy_decision1]=larsen(D1,vel2,vel2_U,V1,vel3,vel3_U,B1,AND,ALSO);

% --- --- Defuzzify consequence

     center_of_gravity=1;
     force1=defzfir(fuzzy_decision1,force1_U,center_of_gravity);

% --- --- Apply control force to system and loop back to the response computation
%         Continue for the time specified
%         us is the control signal
  
        us = force1;
    else
         us = 0;
end




