function [f]=trapeze(x,s,t,c)
%TRAPEZE:  Membership function for matrix X will be drawn using a 
%          trapezoidal shape.
%
%                            [Y]=TRAPEZE(X,a,b,c)
%
%          Where a, b and c are slope, flatness and center of trapezoidal.
%          Defaults value for c and b and a are 0, 0 and 1 respectively.
%
%                          See also BELL_1, BELL_2, SIGMOID, and MF_PANEL.


% FISMAT: Fuzzy Inference Systems toolbox for MATLAB
% (c) A. Lotfi, University of Queensland (Email: lotfia@s1.elec.uq.oz.au)
% 13-10-93
% The program has been tested on MATLAB version 4.1, Sun workstation.

% Modified, Erik A. Johnson <johnsone@nd.edu>, 11/7/97 to get rid of for-loops

if nargin < 4,c=0;end
if nargin < 3,t=0;end
if nargin < 2,s=1;end

if s == 0 , s=eps; end

z=c+t/2+1/s;
y=c-t/2-1/s;

[m,n]=size(x);


%eaj -- old code commented out
%eaj for i=1:m
%eaj for j=1:n
%eaj 
%eaj if x(i,j) >= z | x(i,j) <= y
%eaj     f(i,j) = 0 ;
%eaj elseif x(i,j) < c+t/2 & x(i,j) > c-t/2
%eaj     f(i,j) = 1 ;
%eaj elseif x(i,j) > c
%eaj     f(i,j) = s*(z-x(i,j));
%eaj else
%eaj     f(i,j) = s*(x(i,j)-y);
%eaj end
%eaj 
%eaj end %for j
%eaj end %for i
%eaj -- new code
mask1 = x>=z | x<=y;
mask2 = x<c+t/2 & x>c-t/2 & ~mask1;
mask3 = x>c & ~(mask1|mask2);
mask4 = ~(mask1|mask2|mask3);
f = mask2 + mask3.*s.*(z-x) + mask4.*s.*(x-y);
%eaj -- end of new code
