function [sig_u,sig_xdotdotam,sig_xm,J] = eval_kt(zout,usignal)

%#########################################################################

%  gains: units ---> volts 
  
gain_x_floor = .51;
gain_x_act   = .51;
gain_v_floor = .0204;
gain_v_act   = .0204;
gain_a_floor = 1.0;
gain_a_act   = 0.1;

%#########################################################################	
% RMS Responses:

%*************************************************************************
% Calculate the Hard Contstraints:

% RMS of u should be <= to 1 volt:

	sig_u = std(usignal);

% RMS of mass acceleration should be less than or equal to 2 g's:

	sig_xdotdotam = std(zout(:,12)/gain_a_act);

% RMS of AMD displacement should be less than or equal to 3 cm:

	sig_xm = std(zout(:,4)/gain_x_act);

%*************************************************************************
% Calculate the Values of J:

%-------------------------------------------------------------------------
% J1:

	sig_x30 = 1.31;



	d1 = zout(:,1)/gain_x_floor;
	sig_d1 = std(d1);

	d2 = zout(:,2)/gain_x_floor - zout(:,1)/gain_x_floor;
	sig_d2 = std(d2);

	d3 = zout(:,3)/gain_x_floor - zout(:,2)/gain_x_floor;
	sig_d3 = std(d3);

	sig_d = [sig_d1, sig_d2, sig_d3]/sig_x30;
	J(1) = max(sig_d);

%-------------------------------------------------------------------------
% J2:

	sig_xdotdota30 = 1.79;



	xdotdota1 = zout(:,9)/gain_a_floor;
	sig_xdotdota1 = std(xdotdota1);

	xdotdota2 = zout(:,10)/gain_a_floor;
	sig_xdotdota2 = std(xdotdota2);

	xdotdota3 = zout(:,11)/gain_a_floor;
	sig_xdotdota3 = std(xdotdota3);

	sig_xdotdota = [sig_xdotdota1, sig_xdotdota2, sig_xdotdota3]/ ...
			sig_xdotdota30;
	J(2) = max(sig_xdotdota);

%-------------------------------------------------------------------------
% J3:

	J(3) = sig_xm/sig_x30;

%-------------------------------------------------------------------------
% J4:

	sig_xdot30 = 47.9;


	sig_xdotm = std(zout(:,8)/gain_v_act);

	J(4) = sig_xdotm/sig_xdot30;

%-------------------------------------------------------------------------
% J5:

	J(5) = sig_xdotdotam/sig_xdotdota30;

%#########################################################################
% Save  variables:

	%time_kt = time;
	%usignal_kt = usignal;
	%zout_kt = zout;
%#########################################################################
