function [sig_u,sig_f,sig_xp,J] = eval_kt(zout,usignal)

%#########################################################################

%  gains: units ---> volts 
  
gain_x_floor = .25;
gain_x_act   = 7.87;
gain_v_floor = .0102;
gain_v_act   = .394;
gain_a_floor = 0.5;
gain_f_tendon   = 0.222;

%#########################################################################	
% RMS Responses:

%*************************************************************************
% Calculate the Hard Contstraints:

% RMS of u should be <= to 1 volt:

	sig_u = std(usignal);

% RMS of tendon force should be less than or equal to 4 kN:

	sig_f = std(zout(:,12)/gain_f_tendon);

% RMS of actuator displacement should be less than or equal to 1 cm:

	sig_xp = std(zout(:,4)/gain_x_act);

%*************************************************************************
% Calculate the Values of J:

%-------------------------------------------------------------------------
% J1:

	sig_x30 = 2.34;



	d1 = zout(:,1)/gain_x_floor;
	sig_d1 = std(d1);

	d2 = zout(:,2)/gain_x_floor - zout(:,1)/gain_x_floor;
	sig_d2 = std(d2);

	d3 = zout(:,3)/gain_x_floor - zout(:,2)/gain_x_floor;
	sig_d3 = std(d3);

	sig_d = [sig_d1, sig_d2, sig_d3]/sig_x30;
	J(1) = max(sig_d);

%-------------------------------------------------------------------------
% J2:

	sig_xdotdota30 = 0.485;



	xdotdota1 = zout(:,9)/gain_a_floor;
	sig_xdotdota1 = std(xdotdota1);

	xdotdota2 = zout(:,10)/gain_a_floor;
	sig_xdotdota2 = std(xdotdota2);

	xdotdota3 = zout(:,11)/gain_a_floor;
	sig_xdotdota3 = std(xdotdota3);

	sig_xdotdota = [sig_xdotdota1, sig_xdotdota2, sig_xdotdota3]/ ...
			sig_xdotdota30;
	J(2) = max(sig_xdotdota);

%-------------------------------------------------------------------------
% J3:

	J(3) = sig_xp/sig_x30;

%-------------------------------------------------------------------------
% J4:

	sig_xdot30 = 33.3;


	sig_xdotp = std(zout(:,8)/gain_v_act);

	J(4) = sig_xdotp/sig_xdot30;

%-------------------------------------------------------------------------
% J5:

	Weight = 289;

	J(5) = sig_f/Weight;

%#########################################################################
% Save  variables:

	%time_kt = time;
	%usignal_kt = usignal;
	%zout_kt = zout;
%#########################################################################
