% LQG.m
% This program was used to design the controller
% provided with the Benchmark Problem. 
% 
%
%     Modified by J. C. Wu
%     Aug. 1996

echo on
% LOAD CONTROL DESIGN MODEL
load des_mod

Ar2=Ar; Br2=[Er Br]; 
%Cr2=Cyr; 
%Dr2=[Fyr Dyr];

% DEFINE WEIGHTINGS FOR CONTROL DESIGN
R	= [50];
Q 	= diag([130  100  100  0  0  0  0  0  1  1  10  62]);

% CONTROL DESIGN
Czd	= Czr;	
Dzd	= Dzr;
Czd(2,:)= Czr(2,:)-Czr(1,:);
Czd(3,:)= Czr(3,:)-Czr(2,:);
Dzd(2,:)= Dzr(2,:)-Dzr(1,:);
Dzd(3,:)= Dzr(3,:)-Dzr(2,:);
K	= lqry(Ar,Br,Czd,Dzd,Q,R);

Cyd	= Cyr(1:5,:);
Dyd	= Dyr(1:5,:);
Fyd	= Fyr(1:5,:);
[m,nstate]=size(Cyd);
SW	= 5;
SV	= eye(m);
L	= lqew(Ar,Er,Cyd,Fyd,SW,SV);

% FORM CONTINUOUS STATE-SPACE CONTROLLER
Ac	= Ar - Br*K - L*Cyd + L*Dyd*K;
Bc	= L;
Cc	= -K;
Dc	= zeros(1,m);

% CHECK STABILITY OF CONTROLLER
if (max(real(eig(Ac))) > 0) 
	disp(' ')
	disp('UNSTABLE CONTROLLER !')
end

% CONVERT TO DISCRETE FORM
[Ad,Bd,Cd,Dd] = c2dm(Ac,Bc,Cc,Dc,0.001,'tustin');
% 0.001 is the sampling rate of the DSP Board

save smp_ctrl Ad Bd Cd Dd
echo off
