%   This is a program for computing the compensator coeff. 
%   and the design of controller, after using 'csmcc1_ar.m'.   
%
%   Edited by J. C. Wu
%   Sep. 1996
%
%   input L12, L22, P and D2 in order to
%   compute the other compensator coefficients
%
L12=0.1;
L22=-2;
P1=1;
P2=1;
D2=1;
delta_bar=100.;
%   compute L11, L21 and N1, N2
Geta=-K(1,1:m);
Gq1=-K(1,m+1);
N1=-K(2,1:m);
K44=-K(2,m+1);
L11=L12/P2*P1+K44;
N2=inv(P2)*(-(P2*D2)*Geta-P1*N1);
L21=inv(P2)*(-(P2*D2)*Gq1-P1*K44)+L22/P2*P1;
L=[ L11  L12 ;
    L21  L22];
N=[N1
   N2];
%
%check if L is stable
%
if (max(real(eig(L))) > 0) 
	disp(' ')
	disp('UNSTABLE L, re-input another set of L21,L22 !')
end
%
Mc1=inv(P2*D2)*(P1*L12/P2*P1+P2*L22/P2*P1);
Mc2=inv(P2*D2)*(P1*L12+P2*L22);
K_b=[Geta  Gq1-Mc1-inv(P2*D2)*delta_bar*P1  -Mc2-inv(P2*D2)*delta_bar*P2 ];
%ignore the feedforward
K_f=0;
%
%  form continuous state-space controller
%
Ac=[[Aeta zeros(m,2)];[ N  L]]+[zeros(m+1,1);D2]*K_b;
Bc=[Beta ; zeros(2,m)];
Cc=K_b;
Dc=zeros(1,m);
%
%chech if Ac is stable
%
if (max(real(eig(Ac))) > 0) 
	disp(' ')
	disp('UNSTABLE Ac !')
end
%
%   convert to the discrete form
%   0.001 is the sampling rate od the DSP board
% 
[Ad,Bd,Cd,Dd]=c2dm(Ac,Bc,Cc,Dc,0.001,'tustin');
%
%  save the discrete controller data to a file named 'smp_ctrl'
%
save smp_ctrl Ad Bd Cd Dd
