%   This is a program using Balanced Model Reduction method and 
%   Davison's method (J. C. Wu's dissertation) to reduce
%   the evaluation model in Benchmark Problem 2
%   
%   Edited by J. C. Wu
%   Aug. 1996
%
%  make a similarity transformation to balanced state
%
[Ab Bb Cb g TT]=balreal(A,B,Cz);
Eb=inv(TT)*E;
Db=Dz;
Fb=Fz;
[nstate,nstate]=size(Ab);
%
%  construct the reduced-order system by retaining the
%  same dynamics of the first selected modes
%
k=12 ;  %dimension of the reduced-order system
mod_order=[7 8 9 10 11 12 13 14 15 16 17 18  1 2 3 4 5 6 19 20];
[v1 d]=eig(Ab);
v=v1(:,mod_order);
S=inv(v);
Gamma_star=v(1:k,1:k);
Gamma_bot=v(k+1:nstate,1:k);
Ab_r=Ab(1:k,k+1:nstate);
%
%   compute reduced-order system Ar, Br, Er, Czr, Dzr, Fzr
%
Ar=Ab(1:k,1:k)+Ab_r*real(Gamma_bot*inv(Gamma_star));
Br=real(Gamma_star*S(1:k,:))*Bb;
Er=real(Gamma_star*S(1:k,:))*Eb;
Czr=Cb(:,1:k)+Cb(:,k+1:nstate)*real(Gamma_bot*inv(Gamma_star));
Dzr=Db;
Fzr=Fb;
%
%   measured output matrices extracted from control output
%
Cyr=[ Czr(4,:);
      Czr(9:12,:);
      zeros(1,k)];
Dyr=[ Dzr(4,:);
      Dzr(9:12,:);
        0        ];
Fyr=[ Fzr(4,:);
      Fzr(9:12,:);
        1        ]
