function writefil(controller_name,author,wg,zg,KT_time,prob_string,J, ...
                  sig_u,  sig_f,  sig_xm,  ...
                  EJ, Eu_max, Ef_max, Exp_max, ...
                  HJ, Hu_max, Hf_max, Hxp_max)
                  
% determine filename
filename = controller_name;
if (wg~=14.5), filename=[filename '_wg' strrep(num2str(wg,8),'.','_')]; end;
if (zg~=0.3), filename=[filename '_zg' strrep(num2str(zg,8),'.','_')]; end;
if (KT_time~=750), filename=[filename '_KT' strrep(num2str(KT_time),'.','_')]; end;
v=version; if (eval(v(1))<5), v=''; else, v='.ml5'; end;

% open the file
fid = fopen([filename,'.res',v],'w');
if fid < 2,
  error('Error in opening a file.');
end

% write header info
fprintf(fid,['The following are the results of the simulation for \n\tauthor:\t\t',author,'\n\tcontroller:\t',controller_name,'\n\tMATLAB:\t\t%s\n\n\n'],version);

% write param info
fprintf(fid,'wg:  %f\n',wg);
fprintf(fid,'zg:  %f\n\n',zg);
fprintf(fid,'%s',prob_string);
fprintf(fid,'Time for Kanai-Tajimi simulation:  %f secs\n\n',KT_time);

% write J's
fprintf(fid,'\tMax\t\t\tElCentro\tHachinohe\tKanai-Tajimi\n');
for i=1:5, fprintf(fid,['J',num2str(i),' \t%f\t\t\t\t\t\t%f\n'],J(i),J(i)); end
for i=6:10, fprintf(fid,['J',num2str(i),' \t%f\t\t%f\t%f\n'],J(i),EJ(i-5),HJ(i-5)); end

% KT constraints
fprintf(fid,'\n\nThe following are the control constraint results for the \nKanai-Tajimi simulation. An * indicates a violation of the contraint.\n\n');
fprintf(fid,'Constrained Quantity\t\t Simulation Result\t\tConstraint\n\n');

fprintf(fid,'sigma_u\t\t\t\t');
if sig_u>1.0, fprintf(fid,'*'); else, fprintf(fid,' '); end
fprintf(fid,'%f v ',sig_u);
fprintf(fid,'\t\t\t1.0 v \n');

fprintf(fid,'sigma_force\t\t\t');
if sig_f>4.0, fprintf(fid,'*'); else, fprintf(fid,' '); end
fprintf(fid,'%f kN',sig_f);
fprintf(fid,'\t\t\t4.0 kN\n');

fprintf(fid,'sigma_x_p\t\t\t');
if sig_xm>1.0, fprintf(fid,'*'); else, fprintf(fid,' '); end
fprintf(fid,'%f cm',sig_xm);
fprintf(fid,'\t\t\t1.0 cm\n\n\n');

% Peak constraints
fprintf(fid,'The following are the control constraint results for the El Centro and \nHachinohe earthquake simulations. An * indicates a violation of the contraint.\n\n');
fprintf(fid,'Constrained Quantity\t\t El Centro\t Hachinohe\tConstraint \n\n');

fprintf(fid,'max(abs(u))\t\t\t');
if Eu_max>3.0, fprintf(fid,'*'); else, fprintf(fid,' '); end
fprintf(fid,'%f v \t',Eu_max);
if Hu_max>3.0, fprintf(fid,'*'); else, fprintf(fid,' '); end
fprintf(fid,'%f v ',Hu_max );
fprintf(fid,'\t3.0 v \n');

fprintf(fid,'max(abs(force))\t\t\t');
if Ef_max>12.0, fprintf(fid,'*'); else, fprintf(fid,' '); end
fprintf(fid,'%f kN\t',Ef_max);
if Hf_max>12.0, fprintf(fid,'*'); else, fprintf(fid,' '); end
fprintf(fid,'%f kN',Hf_max );
fprintf(fid,'\t12.0 kN\n');

fprintf(fid,'max(abs(x_p))\t\t\t');
if Exp_max>3.0, fprintf(fid,'*'); else, fprintf(fid,' '); end
fprintf(fid,'%f cm\t',Exp_max);
if Hxp_max>3.0, fprintf(fid,'*'); else, fprintf(fid,' '); end
fprintf(fid,'%f cm',Hxp_max );
fprintf(fid,'\t3.0 cm\n');

% close the file
fclose(fid);
