function [Eu_max,Exm_max,Exdotdotam_max,EJ6,EJ7,EJ8,EJ9,EJ10] = eval_e(zout,usignal)

%#########################################################################

%  gains: units ---> volts 
  
gain_x_floor = .51;
gain_x_act   = .51;
gain_v_floor = .0204;
gain_v_act   = .0204;
gain_a_floor = 1.0;
gain_a_act   = 0.1;

%#########################################################################
% Peak Responses for the El Centro Earthquake:

%************************************************************************
% Calculate the Controller Constraints:

% Max of usignal should be less than or equal to 3 volts:

	Eu_max = max(abs(usignal));

% Max displacement should be less than or equal to 9 cm:

	Exm_max = max(abs(zout(:,4)/gain_x_act));

% Max acceleration should be less than or equal to 6 g's:

	Exdotdotam_max = max(abs(zout(:,12)/gain_a_act));

%************************************************************************
% Calculate the Values of J:

%------------------------------------------------------------------------
% EJ6:

	Ex3o = 3.37;

	Ed1 = zout(:,1)/gain_x_floor;
	Ed1_max = max(abs(Ed1));

	Ed2 = zout(:,2)/gain_x_floor - zout(:,1)/gain_x_floor;
	Ed2_max = max(abs(Ed2));

	Ed3 = zout(:,3)/gain_x_floor - zout(:,2)/gain_x_floor;
	Ed3_max = max(abs(Ed3));

	Ed = [Ed1_max Ed2_max Ed3_max]/Ex3o;
	EJ6 = max(Ed);

%------------------------------------------------------------------------
% EJ7:

	Exdotdota3o = 5.05;

	Exdotdota1 = zout(:,9)/gain_a_floor;
	Exdotdota1_max = max(abs(Exdotdota1));

	Exdotdota2 = zout(:,10)/gain_a_floor;
	Exdotdota2_max = max(abs(Exdotdota2));

	Exdotdota3 = zout(:,11)/gain_a_floor;
	Exdotdota3_max = max(abs(Exdotdota3));

	Exdotdota = [Exdotdota1_max Exdotdota2_max Exdotdota3_max]/Exdotdota3o;
	EJ7 = max(Exdotdota);

%------------------------------------------------------------------------
% EJ8:

	Exm = zout(:,4)/gain_x_act;
	EJ8 = max(abs(Exm)/Ex3o);

%------------------------------------------------------------------------
% EJ9:

	Exdot3o = 131;

	Exdotm = zout(:,8)/gain_v_act;
	EJ9 = max(abs(Exdotm)/Exdot3o);

%------------------------------------------------------------------------
% EJ10:

	Exdotdotm = zout(:,12)/gain_a_act;
	EJ10 = max(abs(Exdotdotm)/Exdotdota3o);

%************************************************************************
% Save some variables:

	%time_e = time;
	%usignal_e = usignal;
	%zout_e = zout;

%#########################################################################
